// IGOR - a birthday-reminder

/*  Copyright (c) 2005-2006 "Meillo  r e t u r n s"

    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated
    documentation files (the "Software"), to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software,
    and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all copies or substantial portions
    of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
    TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
    THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
    CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.

*/


public class Dataset {

  // Consts
  private final String[] monthnamesGerman = {"Januar", "Februar", "März", "April", "Mai", "Juni", "Juli",
                                             "August", "September", "Oktober", "November", "Dezember"};
  private final String[] monthnamesEnglish = {"January", "February", "March", "April", "May", "June", "July",
                                              "August",   "September", "October", "November", "December"};

  // Vars
  private String day;
  private String month;
  private String year;
  private String text;

  // Constructor
  public Dataset(String date, String text) {
    this.day = date.substring(8,10);
    this.month = date.substring(5,7);
    this.year = date.substring(0,4);

    this.text = text;
  }
  public Dataset(String dateAndText) {
    this.day = dateAndText.substring(8,10);
    this.month = dateAndText.substring(5,7);
    this.year = dateAndText.substring(0,4);

    this.text = dateAndText.substring(11);
  }


  // Getter and Setter
  public String getDay() {
    return this.day;
  }
  public int getDayInt() {
    return Integer.parseInt(this.day);
  }

  public String getMonth() {
    return this.month;
  }
  public int getMonthInt() {
    return Integer.parseInt(this.month);
  }

  public String getYear() {
    return this.year;
  }
  public int getYearInt() {
    return Integer.parseInt(this.year);
  }

  public String getText() {
    return this.text;
  }

  public String getDate(String format) {
    if (format.equals("de")) {
      return this.day +". "+ monthnamesGerman[getMonthInt()-1];
    } else if (format.equals("en")) {
      String ordinalSuffix = "";
      if (getDayInt() % 10 == 1 && getDayInt() != 11) {
        ordinalSuffix = "st";
      } else if (getDayInt() % 10 == 2 && getDayInt() != 12) {
        ordinalSuffix = "nd";
      } else {
        ordinalSuffix = "th";
      }
      return monthnamesEnglish[getMonthInt()-1] +" "+ this.day + ordinalSuffix;
    } else {
      return this.day +". "+ monthnamesEnglish[getMonthInt()-1];
    }
  }

}